gtkmm: Gtk::EventControllerKey Class Reference

gtkmm 4.14.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::EventControllerKey Class Reference
Event Controllers and Gestures

Event controller for key events. More...

`#include <gtkmm/eventcontrollerkey.h>`

Inheritance diagram for Gtk::EventControllerKey:
[legend]

## Public Member Functions
| EventControllerKey (EventControllerKey &&src) noexcept
EventControllerKey & | operator= (EventControllerKey &&src) noexcept
| ~EventControllerKey () noexcept override
GtkEventControllerKey * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventControllerKey * | gobj () const
| Provides access to the underlying C GObject.
GtkEventControllerKey * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | forward (Widget &widget)
| Forwards the current event of this controller to a widget.
guint | get_group () const
| Gets the key group of the current event of this controller.
Glib::SignalProxy< bool(guint, guint, Gdk::ModifierType)> | signal_key_pressed ()
Glib::SignalProxy< void(guint, guint, Gdk::ModifierType)> | signal_key_released ()
Glib::SignalProxy< bool(Gdk::ModifierType)> | signal_modifiers ()
Glib::SignalProxy< void()> | signal_im_update ()
Public Member Functions inherited from Gtk::EventController
| EventController (EventController &&src) noexcept
EventController & | operator= (EventController &&src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject.
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Widget * | get_widget ()
| Returns the `Gtk::Widget` this controller relates to.
const Widget * | get_widget () const
| Returns the `Gtk::Widget` this controller relates to.
void | reset ()
| Resets the controller to a clean state.
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events.
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events.
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller.
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller.
Glib::ustring | get_name () const
| Gets the name of controller.
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging.
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller.
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller.
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller.
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller.
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller.
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the `Gdk::Events` that the controller will handle.
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle.
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle.
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< EventControllerKey > | create ()
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| EventControllerKey ()
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::EventControllerKey > | wrap (GtkEventControllerKey *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)

## Detailed Description

Event controller for key events.

Gtk::EventControllerKey is an event controller meant for situations where you need access to key events.

Key values are the codes which are sent whenever a key is pressed or released. The complete list of key values can be found in the gdk/gdkkeysyms.h header file. They are prefixed with `GDK_KEY_`.

Since gtkmm 3.94

## Constructor & Destructor Documentation

## ◆ EventControllerKey() [1/2]

Gtk::EventControllerKey::EventControllerKey | ( | EventControllerKey && | src | ) |
| noexcept

## ◆ ~EventControllerKey()

Gtk::EventControllerKey::~EventControllerKey | ( |  | ) |
| overridenoexcept

## ◆ EventControllerKey() [2/2]

Gtk::EventControllerKey::EventControllerKey | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< EventControllerKey > Gtk::EventControllerKey::create | ( |  | ) |
| static

## ◆ forward()

bool Gtk::EventControllerKey::forward | ( | Widget & | widget | ) |

Forwards the current event of this controller to a widget.

This function can only be used in handlers for the signal_key_pressed(), signal_key_released() or signal_modifiers() signals.

Parameters

  widget | A `Gtk::Widget`.

Returns
  Whether the widget handled the event.

## ◆ get_group()

guint Gtk::EventControllerKey::get_group | ( |  | ) | const

Gets the key group of the current event of this controller.

See Gdk::KeyEvent::get_layout().

Returns
  The key group.

## ◆ get_type()

static GType Gtk::EventControllerKey::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkEventControllerKey * Gtk::EventControllerKey::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkEventControllerKey * Gtk::EventControllerKey::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkEventControllerKey * Gtk::EventControllerKey::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

EventControllerKey & Gtk::EventControllerKey::operator= | ( | EventControllerKey && | src | ) |
| noexcept

## ◆ signal_im_update()

Glib::SignalProxy< void()> Gtk::EventControllerKey::signal_im_update | ( |  | ) |

Slot Prototype:
  `void on_my_im_update()`

Flags: Run Last

Emitted whenever the input method context filters away a keypress and prevents the controller receiving it.

See Gtk::EventControllerKey::set_im_context() and Gtk::IMContext::filter_keypress().

## ◆ signal_key_pressed()

Glib::SignalProxy< bool(guint, guint, Gdk::ModifierType)> Gtk::EventControllerKey::signal_key_pressed | ( |  | ) |

Slot Prototype:
  `bool on_my_key_pressed(guint keyval, guint keycode, Gdk::ModifierType state)`

Flags: Run Last

Emitted whenever a key is pressed.

Parameters

  keyval | The pressed key.
  keycode | The raw code of the pressed key.
  state | The bitmask, representing the state of modifier keys and pointer buttons.

Returns
  `true` if the key press was handled, `false` otherwise.

## ◆ signal_key_released()

Glib::SignalProxy< void(guint, guint, Gdk::ModifierType)> Gtk::EventControllerKey::signal_key_released | ( |  | ) |

Slot Prototype:
  `void on_my_key_released(guint keyval, guint keycode, Gdk::ModifierType state)`

Flags: Run Last

Emitted whenever a key is released.

Parameters

  keyval | The released key.
  keycode | The raw code of the released key.
  state | The bitmask, representing the state of modifier keys and pointer buttons.

## ◆ signal_modifiers()

Glib::SignalProxy< bool(Gdk::ModifierType)> Gtk::EventControllerKey::signal_modifiers | ( |  | ) |

Slot Prototype:
  `bool on_my_modifiers(Gdk::ModifierType state)`

Flags: Run Last

This signal is emitted whenever the state of modifier keys and pointer buttons change.

Parameters

  state | The bitmask, representing the new state of modifier keys and pointer buttons. See Gdk::ModifierType.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::EventControllerKey > wrap | ( | GtkEventControllerKey * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.